




/*
 * This is a generated file. Do not edit this file.
 */
package weblogic.management.security;

import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.CRC32;
import weblogic.descriptor.*;
import weblogic.descriptor.BeanUpdateEvent.PropertyUpdate;
import weblogic.descriptor.internal.*;
import weblogic.descriptor.internal.ReferenceManager.Resolver;
import weblogic.descriptor.beangen.LegalChecks;
import weblogic.descriptor.beangen.StringHelper;
import weblogic.utils.ArrayUtils;
import weblogic.utils.StringUtils;
import weblogic.utils.Debug;
import weblogic.utils.collections.ArrayIterator;
import weblogic.utils.collections.CombinedIterator;
import weblogic.descriptor.internal.Munger.ReaderEventInfo;

import weblogic.descriptor.DescriptorBean;
import weblogic.management.commo.StandardInterface;
import javax.management.InvalidAttributeValueException;


/**
 * Corresponds to ProviderMBean
 * (Interface=weblogic.management.security.ProviderMBean)
 * @author Copyright (c) 2003,2014, Oracle and/or its affiliates. All rights reserved.
 * @version 0.1
 *
 * The base MBean for all security providers.
 <p>
 It includes attributes common to all security providers.
 Every security provider must implement an MBean that
 extends this MBean.</p>
 <p>
 If the security provider supports management methods, the management 
 methods cannot be called until the validate method of realm in which
 the security provider is configured successfully returns. That is,
 the administrator must completely configure the realm before
 using the management methods (for example, adding a user).
 </p>
 *
 * @xsdgen:complexType.typeName providerType
 * @xsdgen:complexType.targetNamespace http://xmlns.oracle.com/weblogic/security
 * @xsdgen:complexType.ignoreSuper
 */
public class ProviderMBeanImpl
  extends weblogic.management.commo.AbstractCommoConfigurationBean
  implements ProviderMBean, java.io.Serializable
{
  private String _CompatibilityObjectName;
  private String _Description;
  private String _Name;
  private String _ProviderClassName;
  private RealmMBean _Realm;
  private String _Version;
  private transient ProviderImpl _customizer;


  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=ProviderMBeanImpl)
   *
   */
  public ProviderMBeanImpl() {
    super();
    try {
      _customizer = new weblogic.management.security.ProviderImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=ProviderMBeanImpl)
   *
   */
  public ProviderMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1) {
    super(param0, param1);
    try {
      _customizer = new weblogic.management.security.ProviderImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=ProviderMBeanImpl)
   *
   */
  public ProviderMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1, boolean param2) {
    super(param0, param1);
    _setTransient(param2);
    try {
      _customizer = new weblogic.management.security.ProviderImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * Returns the name of the Java class used to load this security provider.
 <p>
 Each security provider must implement a runtime class (e.g.
 <code>com.acme.MyAuthenticationProviderImpl</code>)
 which extends provider type specific interface in <code>weblogic.security.spi</code>
 (e.g. <code>weblogic.security.spi.AuthorizationProvider</code>).
 </p>
 The security provider  must also implement an MBean which ultimately
 extends this MBean.

 The  security provider's MBean must set the default
 value of this read-only attribute the fully qualified classname of the
 security provider's runtime class (e.g. <code>com.acme.MyAuthenticationProviderImpl</code>).
 In other words, the security provider's MBean hard-wires
 the name of its runtime class.
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getProviderClassName)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public String getProviderClassName() {
    return _ProviderClassName;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isProviderClassNameInherited)
   *
   * return true if the value of property ProviderClassName is inherited from template
   */
  public boolean isProviderClassNameInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isProviderClassNameSet)
   *
   * @xsdgen:isSetMethodFor provider-class-name
   */
  public boolean isProviderClassNameSet() {
    return _isSet(2);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setProviderClassName)
   *
   */
  public void setProviderClassName(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    _ProviderClassName = param0;
  }

  /**
   * Returns a description of this security provider.
 <p>
 Each security provider's MBean should set the default value
 of this read-only attribute to a string that describes the
 provider.  In other words, each security provider's MBean
 hard-wires its description.  There are no conventions
 governing the contents of the description.  It should be a human
 readable string that gives a brief description of the security provider.
 </p>
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getDescription)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public String getDescription() {
    return _Description;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isDescriptionInherited)
   *
   * return true if the value of property Description is inherited from template
   */
  public boolean isDescriptionInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isDescriptionSet)
   *
   * @xsdgen:isSetMethodFor description
   */
  public boolean isDescriptionSet() {
    return _isSet(3);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setDescription)
   *
   */
  public void setDescription(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    _Description = param0;
  }

  /**
   * Returns this security provider's version.
 <p>
 Each security provider's MBean should set the default value
 of this read-only attribute to a string that specifies the version
 of the provider (e.g. 7.3.04).  In other words, each
 security provider's MBean hard-wires its version.  There
 are no conventions governing the contents of the version string.
 </p>
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getVersion)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public String getVersion() {
    return _Version;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isVersionInherited)
   *
   * return true if the value of property Version is inherited from template
   */
  public boolean isVersionInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isVersionSet)
   *
   * @xsdgen:isSetMethodFor version
   */
  public boolean isVersionSet() {
    return _isSet(4);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setVersion)
   *
   */
  public void setVersion(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    _Version = param0;
  }

  /**
   * Returns the realm that contains this security provider.
 Returns null if this security provider is not contained by a realm.
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getRealm)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public RealmMBean getRealm() {
    return _customizer.getRealm();
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isRealmInherited)
   *
   * return true if the value of property Realm is inherited from template
   */
  public boolean isRealmInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isRealmSet)
   *
   * @xsdgen:isSetMethodFor realm
   */
  public boolean isRealmSet() {
    return _isSet(5);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setRealm)
   *
   */
  public void setRealm(RealmMBean param0)
    throws javax.management.InvalidAttributeValueException
  {
    _Realm = param0;
  }

  /**
   * The name of this configuration. WebLogic Server uses an MBean to
 implement and persist the configuration.
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getName)
   *
   * @xsdgen:element.name name
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @xsdgen:element.default Provider
   * @dynamic false
   */
  public String getName() {
    return _Name;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isNameInherited)
   *
   * return true if the value of property Name is inherited from template
   */
  public boolean isNameInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isNameSet)
   *
   * @xsdgen:isSetMethodFor name
   */
  public boolean isNameSet() {
    return _isSet(6);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setName)
   *
   */
  public void setName(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    String _oldVal = _Name;
    _Name = param0;
    _postSet(6, _oldVal, param0);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=getCompatibilityObjectName)
   *
   * @xsdgen:element.name compatibility-object-name
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @dynamic false
   */
  public String getCompatibilityObjectName() {
    return _customizer.getCompatibilityObjectName();
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isCompatibilityObjectNameInherited)
   *
   * return true if the value of property CompatibilityObjectName is inherited from template
   */
  public boolean isCompatibilityObjectNameInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=isCompatibilityObjectNameSet)
   *
   * @xsdgen:isSetMethodFor compatibility-object-name
   */
  public boolean isCompatibilityObjectNameSet() {
    return _isSet(7);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=setCompatibilityObjectName)
   *
   */
  public void setCompatibilityObjectName(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    String _oldVal = _CompatibilityObjectName;
    _CompatibilityObjectName = param0;
    _postSet(7, _oldVal, param0);
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=_getKey)
   *
   */
  public Object _getKey() {
    return super._getKey();
  }

  /**
   * 
   * (Interface=weblogic.management.security.ProviderMBean Attribute=_validate)
   *
   */
  public void _validate()
    throws IllegalArgumentException
  {
    super._validate();
  }



 





  protected void _unSet(int idx) {
    if (!_initializeProperty(idx)) {
      super._unSet(idx);
    } else {
      _markSet(idx, false);
    }
  }


  /**
   * @return new instance of helper
   */
  protected AbstractDescriptorBeanHelper _createHelper() {
    return new Helper(this);
  }

  /**
   * @return true if any property is set
   */
  public boolean _isAnythingSet() {
    return super._isAnythingSet()
      ;
  }



  /**
   * @return true if property initialized, false idx refers to a property
   * handled by superclass
   */
  private boolean _initializeProperty(int idx) {
    boolean initOne = idx > -1;
    if (!initOne) {
      idx = 7;
    }
    try {
      switch (idx) {
      case 7:
        _CompatibilityObjectName = null;
        if (initOne) break;
      case 3:
        _Description = null;
        if (initOne) break;
      case 6:
        _Name = "Provider";
        if (initOne) break;
      case 2:
        _ProviderClassName = null;
        if (initOne) break;
      case 5:
        _Realm = null;
        if (initOne) break;
      case 4:
        _Version = null;
        if (initOne) break;
      default:
        if (initOne) return false;
      }
      return true;
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw (Error)new AssertionError("Impossible Exception").initCause(e);
    }
  }


  /**
   * This helper class contains methods that are used infrequently and
   * can be easily separated from the bean implementations.  It is loaded
   * on demand to minimize memory usage.
   *
   * @xsdgen:complexType.exclude
   */
  protected static class Helper
    extends weblogic.management.commo.AbstractCommoConfigurationBean.Helper
  {
    private ProviderMBeanImpl bean;

    protected Helper(ProviderMBeanImpl bean) {
      super(bean);
      this.bean = bean;
    }

    /**
     * @return property name indexed by propIndex.
     */
    public String getPropertyName(int propIndex) {
      switch (propIndex) {
      case 7: return "CompatibilityObjectName";
      case 3: return "Description";
      case 6: return "Name";
      case 2: return "ProviderClassName";
      case 5: return "Realm";
      case 4: return "Version";
      default: return super.getPropertyName(propIndex);
      }
    }


    /**
     * @return property index of propName.
     */
    public int getPropertyIndex(String propName) {
      if (false) return -1;
      else if (propName.equals("CompatibilityObjectName")) return 7;
      else if (propName.equals("Description")) return 3;
      else if (propName.equals("Name")) return 6;
      else if (propName.equals("ProviderClassName")) return 2;
      else if (propName.equals("Realm")) return 5;
      else if (propName.equals("Version")) return 4;
      else return super.getPropertyIndex(propName);
    }

    /**
     * @return iterator over all children
     */
    public Iterator getChildren() {
      List iterators = new ArrayList();
      return new CombinedIterator(iterators);
    }

    /**
     * Compute hash value for version helper
     */
    protected long computeHashValue(CRC32 crc) {
      try {
        StringBuffer buf = new StringBuffer();
        long superValue = super.computeHashValue(crc);
        if (superValue != 0) {
          buf.append(String.valueOf(superValue));
        }

        long childValue = 0;
        if (bean.isCompatibilityObjectNameSet()){
          buf.append("CompatibilityObjectName");
          buf.append(String.valueOf(bean.getCompatibilityObjectName()));
        }
        if (bean.isDescriptionSet()){
          buf.append("Description");
          buf.append(String.valueOf(bean.getDescription()));
        }
        if (bean.isNameSet()){
          buf.append("Name");
          buf.append(String.valueOf(bean.getName()));
        }
        if (bean.isProviderClassNameSet()){
          buf.append("ProviderClassName");
          buf.append(String.valueOf(bean.getProviderClassName()));
        }
        if (bean.isRealmSet()){
          buf.append("Realm");
          buf.append(String.valueOf(bean.getRealm()));
        }
        if (bean.isVersionSet()){
          buf.append("Version");
          buf.append(String.valueOf(bean.getVersion()));
        }
        crc.update(buf.toString().getBytes());
        return crc.getValue();
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }
    /**
     * Compute difference between this and other
     */
    protected void computeDiff(AbstractDescriptorBean other) {
      try {
        super.computeDiff(other);
      ProviderMBeanImpl otherTyped = (ProviderMBeanImpl)other;
      computeDiff("CompatibilityObjectName", bean.getCompatibilityObjectName(), otherTyped.getCompatibilityObjectName(), false);
      computeDiff("Name", bean.getName(), otherTyped.getName(), false);
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void applyPropertyUpdate(BeanUpdateEvent event, PropertyUpdate update) {
      try {
        ProviderMBeanImpl original = (ProviderMBeanImpl)event.getSourceBean();
        ProviderMBeanImpl proposed = (ProviderMBeanImpl)event.getProposedBean();
        String prop = update.getPropertyName();
        int type = update.getUpdateType();
        if (update.isDerivedUpdate()) {
          return;
        }
        if (prop.equals("CompatibilityObjectName")) {
          original._conditionalUnset(update.isUnsetUpdate(), 7);
        } else
        if (prop.equals("Description")) {
        } else
        if (prop.equals("Name")) {
          original.setName(proposed.getName());
          original._conditionalUnset(update.isUnsetUpdate(), 6);
        } else
        if (prop.equals("ProviderClassName")) {
        } else
        if (prop.equals("Realm")) {
        } else
        if (prop.equals("Version")) {
        } else
        {
          super.applyPropertyUpdate(event, update);
        }
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected AbstractDescriptorBean finishCopy(
    AbstractDescriptorBean initialCopy, boolean includeObsolete, List excludeProps
    ) {
      Object o;
      try {
        ProviderMBeanImpl copy = (ProviderMBeanImpl)initialCopy;
        super.finishCopy(copy, includeObsolete, excludeProps);
        if ((excludeProps == null || !excludeProps.contains("CompatibilityObjectName")) && bean.isCompatibilityObjectNameSet()) {
        }
        if ((excludeProps == null || !excludeProps.contains("Name")) && bean.isNameSet()) {
          copy.setName((String)bean.getName());
        }
        return copy;
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void inferSubTree(Class clazz, Object annotation) {
    	super.inferSubTree(clazz, annotation);
    	Object currentAnnotation = null;
             		inferSubTree(bean.getRealm(), clazz, annotation);
          }
  }


  // FIXME ec@weblogic.com 01-Feb-05 -- no longer used. Remove when ADB method is removed
  public weblogic.descriptor.internal.Munger.SchemaHelper _getSchemaHelper() {
    return null;
  }

  // FIXME ec@weblogic.com 01-Feb-05 -- remove
  public String _getElementName(int propIndex) {
    return _getSchemaHelper2().getElementName(propIndex);
  }

  protected String getSchemaLocation() {
    return "http://xmlns.oracle.com/weblogic/1.0/security.xsd";
  }

  protected String getTargetNamespace() {
    return "http://xmlns.oracle.com/weblogic/security";
  }

  private static SchemaHelper2 _schemaHelper;
  public weblogic.descriptor.internal.SchemaHelper _getSchemaHelper2() {
    if (_schemaHelper == null)
	_schemaHelper = new SchemaHelper2();
    return _schemaHelper;
  }

   // new schema helper
  /**
   * @xsdgen:complexType.exclude
   */
  public static class SchemaHelper2
   extends weblogic.descriptor.internal.AbstractSchemaHelper2
   implements weblogic.descriptor.internal.SchemaHelper
  {
    public int getPropertyIndex(String s) {
      switch(s.length()) {
      case 25:
        if (false) return -1;
        else if (s.equals("compatibility-object-name"))
          return 7;
        break;
      case 11:
        if (false) return -1;
        else if (s.equals("description"))
          return 3;
        break;
      case 4:
        if (false) return -1;
        else if (s.equals("name"))
          return 6;
        break;
      case 19:
        if (false) return -1;
        else if (s.equals("provider-class-name"))
          return 2;
        break;
      case 5:
        if (false) return -1;
        else if (s.equals("realm"))
          return 5;
        break;
      case 7:
        if (false) return -1;
        else if (s.equals("version"))
          return 4;
        break;
      default:
        break;
      }
      return super.getPropertyIndex(s);
    }

    public weblogic.descriptor.internal.SchemaHelper getSchemaHelper(int propIndex) {
      switch(propIndex) {
      default:
        return super.getSchemaHelper(propIndex);
      }
    }



    public String getElementName(int propIndex) {
      switch (propIndex) {
        case 7: return "compatibility-object-name";
        case 3: return "description";
        case 6: return "name";
        case 2: return "provider-class-name";
        case 5: return "realm";
        case 4: return "version";
        default: return super.getElementName(propIndex);
      }
    }






    public boolean isBean(int propIndex) {
      switch(propIndex) {
      default:
        return super.isBean(propIndex);
      }
    }










  }




  public String wls_getInterfaceClassName() {
    return "weblogic.management.security.ProviderMBean"; 
  }

}
