




/*
 * This is a generated file. Do not edit this file.
 */
package weblogic.management.security.authentication;

import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.CRC32;
import weblogic.descriptor.*;
import weblogic.descriptor.BeanUpdateEvent.PropertyUpdate;
import weblogic.descriptor.internal.*;
import weblogic.descriptor.internal.ReferenceManager.Resolver;
import weblogic.descriptor.beangen.LegalChecks;
import weblogic.descriptor.beangen.StringHelper;
import weblogic.utils.ArrayUtils;
import weblogic.utils.StringUtils;
import weblogic.utils.Debug;
import weblogic.utils.collections.ArrayIterator;
import weblogic.utils.collections.CombinedIterator;
import weblogic.descriptor.internal.Munger.ReaderEventInfo;

import javax.management.InvalidAttributeValueException;


/**
 * Corresponds to IdentityAsserterMBean
 * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean)
 * @author Copyright (c) 2003,2014, Oracle and/or its affiliates. All rights reserved.
 * @version 0.1
 *
 * The SSPI MBean that all Identity Assertion providers must extend.
 This MBean enables an Identity Assertion provider to specify the token types for
 which it is capable of asserting identity.
 *
 * @xsdgen:complexType.typeName identity-asserterType
 * @xsdgen:complexType.targetNamespace http://xmlns.oracle.com/weblogic/security
 */
public class IdentityAsserterMBeanImpl
  extends AuthenticationProviderMBeanImpl
  implements IdentityAsserterMBean, java.io.Serializable
{
  private String[] _ActiveTypes;
  private boolean _Base64DecodingRequired;
  private String _CompatibilityObjectName;
  private weblogic.management.security.RealmMBean _Realm;
  private String[] _SupportedTypes;
  private transient IdentityAsserterImpl _customizer;


  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=IdentityAsserterMBeanImpl)
   *
   */
  public IdentityAsserterMBeanImpl() {
    super();
    try {
      _customizer = new weblogic.management.security.authentication.IdentityAsserterImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=IdentityAsserterMBeanImpl)
   *
   */
  public IdentityAsserterMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1) {
    super(param0, param1);
    try {
      _customizer = new weblogic.management.security.authentication.IdentityAsserterImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=IdentityAsserterMBeanImpl)
   *
   */
  public IdentityAsserterMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1, boolean param2) {
    super(param0, param1);
    _setTransient(param2);
    try {
      _customizer = new weblogic.management.security.authentication.IdentityAsserterImpl(new weblogic.management.commo.RequiredModelMBeanWrapper(this));
    } catch (Exception e) {
      if (e instanceof RuntimeException)
        throw (RuntimeException)e;
      throw new java.lang.reflect.UndeclaredThrowableException(e);
    }
    _initializeProperty(-1);
  }

  /**
   * <p>Returns the list of token types supported by the Identity Assertion provider.</p>
 
 <p>To see a list of default token types, refer the Javadoc for 
 <code>weblogic.security.spi.IdentityAsserter</code></p>
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=getSupportedTypes)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public String[] getSupportedTypes() {
    return _SupportedTypes;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isSupportedTypesInherited)
   *
   * return true if the value of property SupportedTypes is inherited from template
   */
  public boolean isSupportedTypesInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isSupportedTypesSet)
   *
   * @xsdgen:isSetMethodFor supported-type
   */
  public boolean isSupportedTypesSet() {
    return _isSet(8);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=setSupportedTypes)
   *
   */
  public void setSupportedTypes(String[] param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? new String[0] : param0;
    param0 = _getHelper()._trimElements(param0);
    _SupportedTypes = param0;
  }

  /**
   * Returns the token types that the Identity Assertion provider is currently
 configured to process.
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=getActiveTypes)
   *
   * @xsdgen:element.name active-type
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @dynamic false
   */
  public String[] getActiveTypes() {
    return _ActiveTypes;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isActiveTypesInherited)
   *
   * return true if the value of property ActiveTypes is inherited from template
   */
  public boolean isActiveTypesInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isActiveTypesSet)
   *
   * @xsdgen:isSetMethodFor active-type
   */
  public boolean isActiveTypesSet() {
    return _isSet(9);
  }

  /**
   * Sets the token types that the Identity Assertion provider will process.
 Only types from the Identity Assertion provider's <code>SupportedTypes</code>
 attribute may be specified.
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=setActiveTypes)
   *
   */
  public void setActiveTypes(String[] param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? new String[0] : param0;
    param0 = _getHelper()._trimElements(param0);
    String[] _oldVal = _ActiveTypes;
    _ActiveTypes = param0;
    _postSet(9, _oldVal, param0);
  }

  /**
   * Returns whether the tokens that are passed to the Identity Assertion provider
 will be base64 decoded first.

 If <code>false</code> then the server will not base64 decode the token
 before passing it to the identity asserter.
 This defaults to <code>true</code> for backwards compatibility but
 most providers will probably want to set this to <code>false</code>.
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=getBase64DecodingRequired)
   *
   * @xsdgen:element.name base64-decoding-required
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @xsdgen:element.default true
   * @dynamic false
   */
  public boolean getBase64DecodingRequired() {
    return _Base64DecodingRequired;
  }

  /**
   * Returns the realm that contains this security provider.
 Returns null if this security provider is not contained by a realm.
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=getRealm)
   *
   * @xsdgen:element.exclude
   * @transient
   */
  public weblogic.management.security.RealmMBean getRealm() {
    return _customizer.getRealm();
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isBase64DecodingRequiredInherited)
   *
   * return true if the value of property Base64DecodingRequired is inherited from template
   */
  public boolean isBase64DecodingRequiredInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isBase64DecodingRequiredSet)
   *
   * @xsdgen:isSetMethodFor base64-decoding-required
   */
  public boolean isBase64DecodingRequiredSet() {
    return _isSet(10);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isRealmInherited)
   *
   * return true if the value of property Realm is inherited from template
   */
  public boolean isRealmInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isRealmSet)
   *
   * @xsdgen:isSetMethodFor realm
   */
  public boolean isRealmSet() {
    return _isSet(5);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=setRealm)
   *
   */
  public void setRealm(weblogic.management.security.RealmMBean param0)
    throws javax.management.InvalidAttributeValueException
  {
    _Realm = param0;
  }

  /**
   * Sets whether the tokens that are passed to the Identity Assertion provider
 will be base64 decoded first.
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=setBase64DecodingRequired)
   *
   */
  public void setBase64DecodingRequired(boolean param0)
    throws javax.management.InvalidAttributeValueException
  {
    boolean _oldVal = _Base64DecodingRequired;
    _Base64DecodingRequired = param0;
    _postSet(10, _oldVal, param0);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=getCompatibilityObjectName)
   *
   * @xsdgen:element.name compatibility-object-name
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @dynamic false
   */
  public String getCompatibilityObjectName() {
    return _customizer.getCompatibilityObjectName();
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isCompatibilityObjectNameInherited)
   *
   * return true if the value of property CompatibilityObjectName is inherited from template
   */
  public boolean isCompatibilityObjectNameInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=isCompatibilityObjectNameSet)
   *
   * @xsdgen:isSetMethodFor compatibility-object-name
   */
  public boolean isCompatibilityObjectNameSet() {
    return _isSet(7);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=setCompatibilityObjectName)
   *
   */
  public void setCompatibilityObjectName(String param0)
    throws javax.management.InvalidAttributeValueException
  {
    param0 = (param0 == null) ? null : param0.trim();
    String _oldVal = _CompatibilityObjectName;
    _CompatibilityObjectName = param0;
    _postSet(7, _oldVal, param0);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=_getKey)
   *
   */
  public Object _getKey() {
    return super._getKey();
  }

  /**
   * 
   * (Interface=weblogic.management.security.authentication.IdentityAsserterMBean Attribute=_validate)
   *
   */
  public void _validate()
    throws IllegalArgumentException
  {
    super._validate();
    try { if (!(_customizer.validateActiveTypes(getActiveTypes()))) throw new IllegalArgumentException("The IdentityAsserter ActiveTypes attribute was set to an illegal value."); } catch (javax.management.InvalidAttributeValueException e) { throw new IllegalArgumentException(e.toString()); };
  }



 





  protected void _unSet(int idx) {
    if (!_initializeProperty(idx)) {
      super._unSet(idx);
    } else {
      _markSet(idx, false);
    }
  }


  /**
   * @return new instance of helper
   */
  protected AbstractDescriptorBeanHelper _createHelper() {
    return new Helper(this);
  }

  /**
   * @return true if any property is set
   */
  public boolean _isAnythingSet() {
    return super._isAnythingSet()
      ;
  }



  /**
   * @return true if property initialized, false idx refers to a property
   * handled by superclass
   */
  private boolean _initializeProperty(int idx) {
    boolean initOne = idx > -1;
    if (!initOne) {
      idx = 9;
    }
    try {
      switch (idx) {
      case 9:
        _ActiveTypes = new String[]{};
        if (initOne) break;
      case 10:
        _Base64DecodingRequired = true;
        if (initOne) break;
      case 7:
        _CompatibilityObjectName = null;
        if (initOne) break;
      case 5:
        _Realm = null;
        if (initOne) break;
      case 8:
        _SupportedTypes = new String[]{};
        if (initOne) break;
      default:
        if (initOne) return false;
      }
      return true;
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw (Error)new AssertionError("Impossible Exception").initCause(e);
    }
  }


  /**
   * This helper class contains methods that are used infrequently and
   * can be easily separated from the bean implementations.  It is loaded
   * on demand to minimize memory usage.
   *
   * @xsdgen:complexType.exclude
   */
  protected static class Helper
    extends AuthenticationProviderMBeanImpl.Helper
  {
    private IdentityAsserterMBeanImpl bean;

    protected Helper(IdentityAsserterMBeanImpl bean) {
      super(bean);
      this.bean = bean;
    }

    /**
     * @return property name indexed by propIndex.
     */
    public String getPropertyName(int propIndex) {
      switch (propIndex) {
      case 9: return "ActiveTypes";
      case 10: return "Base64DecodingRequired";
      case 7: return "CompatibilityObjectName";
      case 5: return "Realm";
      case 8: return "SupportedTypes";
      default: return super.getPropertyName(propIndex);
      }
    }


    /**
     * @return property index of propName.
     */
    public int getPropertyIndex(String propName) {
      if (false) return -1;
      else if (propName.equals("ActiveTypes")) return 9;
      else if (propName.equals("Base64DecodingRequired")) return 10;
      else if (propName.equals("CompatibilityObjectName")) return 7;
      else if (propName.equals("Realm")) return 5;
      else if (propName.equals("SupportedTypes")) return 8;
      else return super.getPropertyIndex(propName);
    }

    /**
     * @return iterator over all children
     */
    public Iterator getChildren() {
      List iterators = new ArrayList();
      return new CombinedIterator(iterators);
    }

    /**
     * Compute hash value for version helper
     */
    protected long computeHashValue(CRC32 crc) {
      try {
        StringBuffer buf = new StringBuffer();
        long superValue = super.computeHashValue(crc);
        if (superValue != 0) {
          buf.append(String.valueOf(superValue));
        }

        long childValue = 0;
        if (bean.isActiveTypesSet()){
          buf.append("ActiveTypes");
          buf.append(Arrays.toString(ArrayUtils.copyAndSort(bean.getActiveTypes())));
        }
        if (bean.isBase64DecodingRequiredSet()){
          buf.append("Base64DecodingRequired");
          buf.append(String.valueOf(bean.getBase64DecodingRequired()));
        }
        if (bean.isCompatibilityObjectNameSet()){
          buf.append("CompatibilityObjectName");
          buf.append(String.valueOf(bean.getCompatibilityObjectName()));
        }
        if (bean.isRealmSet()){
          buf.append("Realm");
          buf.append(String.valueOf(bean.getRealm()));
        }
        if (bean.isSupportedTypesSet()){
          buf.append("SupportedTypes");
          buf.append(Arrays.toString(ArrayUtils.copyAndSort(bean.getSupportedTypes())));
        }
        crc.update(buf.toString().getBytes());
        return crc.getValue();
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }
    /**
     * Compute difference between this and other
     */
    protected void computeDiff(AbstractDescriptorBean other) {
      try {
        super.computeDiff(other);
      IdentityAsserterMBeanImpl otherTyped = (IdentityAsserterMBeanImpl)other;
      computeDiff("ActiveTypes", bean.getActiveTypes(), otherTyped.getActiveTypes(), false);
      computeDiff("Base64DecodingRequired", bean.getBase64DecodingRequired(), otherTyped.getBase64DecodingRequired(), false);
      computeDiff("CompatibilityObjectName", bean.getCompatibilityObjectName(), otherTyped.getCompatibilityObjectName(), false);
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void applyPropertyUpdate(BeanUpdateEvent event, PropertyUpdate update) {
      try {
        IdentityAsserterMBeanImpl original = (IdentityAsserterMBeanImpl)event.getSourceBean();
        IdentityAsserterMBeanImpl proposed = (IdentityAsserterMBeanImpl)event.getProposedBean();
        String prop = update.getPropertyName();
        int type = update.getUpdateType();
        if (update.isDerivedUpdate()) {
          return;
        }
        if (prop.equals("ActiveTypes")) {
          original.setActiveTypes(proposed.getActiveTypes());
          original._conditionalUnset(update.isUnsetUpdate(), 9);
        } else
        if (prop.equals("Base64DecodingRequired")) {
          original.setBase64DecodingRequired(proposed.getBase64DecodingRequired());
          original._conditionalUnset(update.isUnsetUpdate(), 10);
        } else
        if (prop.equals("CompatibilityObjectName")) {
          original._conditionalUnset(update.isUnsetUpdate(), 7);
        } else
        if (prop.equals("Realm")) {
        } else
        if (prop.equals("SupportedTypes")) {
        } else
        {
          super.applyPropertyUpdate(event, update);
        }
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected AbstractDescriptorBean finishCopy(
    AbstractDescriptorBean initialCopy, boolean includeObsolete, List excludeProps
    ) {
      Object o;
      try {
        IdentityAsserterMBeanImpl copy = (IdentityAsserterMBeanImpl)initialCopy;
        super.finishCopy(copy, includeObsolete, excludeProps);
        if ((excludeProps == null || !excludeProps.contains("ActiveTypes")) && bean.isActiveTypesSet()) {
          o = bean.getActiveTypes();
          copy.setActiveTypes((o == null) ? null : (String[])((String[])o).clone());
        }
        if ((excludeProps == null || !excludeProps.contains("Base64DecodingRequired")) && bean.isBase64DecodingRequiredSet()) {
          copy.setBase64DecodingRequired((boolean)bean.getBase64DecodingRequired());
        }
        if ((excludeProps == null || !excludeProps.contains("CompatibilityObjectName")) && bean.isCompatibilityObjectNameSet()) {
        }
        return copy;
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void inferSubTree(Class clazz, Object annotation) {
    	super.inferSubTree(clazz, annotation);
    	Object currentAnnotation = null;
          		inferSubTree(bean.getRealm(), clazz, annotation);
          }
  }


  // FIXME ec@weblogic.com 01-Feb-05 -- no longer used. Remove when ADB method is removed
  public weblogic.descriptor.internal.Munger.SchemaHelper _getSchemaHelper() {
    return null;
  }

  // FIXME ec@weblogic.com 01-Feb-05 -- remove
  public String _getElementName(int propIndex) {
    return _getSchemaHelper2().getElementName(propIndex);
  }

  protected String getSchemaLocation() {
    return "http://xmlns.oracle.com/weblogic/1.0/security.xsd";
  }

  protected String getTargetNamespace() {
    return "http://xmlns.oracle.com/weblogic/security";
  }

  private static SchemaHelper2 _schemaHelper;
  public weblogic.descriptor.internal.SchemaHelper _getSchemaHelper2() {
    if (_schemaHelper == null)
	_schemaHelper = new SchemaHelper2();
    return _schemaHelper;
  }

   // new schema helper
  /**
   * @xsdgen:complexType.exclude
   */
  public static class SchemaHelper2
   extends AuthenticationProviderMBeanImpl.SchemaHelper2
   implements weblogic.descriptor.internal.SchemaHelper
  {
    public int getPropertyIndex(String s) {
      switch(s.length()) {
      case 11:
        if (false) return -1;
        else if (s.equals("active-type"))
          return 9;
        break;
      case 24:
        if (false) return -1;
        else if (s.equals("base64-decoding-required"))
          return 10;
        break;
      case 25:
        if (false) return -1;
        else if (s.equals("compatibility-object-name"))
          return 7;
        break;
      case 5:
        if (false) return -1;
        else if (s.equals("realm"))
          return 5;
        break;
      case 14:
        if (false) return -1;
        else if (s.equals("supported-type"))
          return 8;
        break;
      default:
        break;
      }
      return super.getPropertyIndex(s);
    }

    public weblogic.descriptor.internal.SchemaHelper getSchemaHelper(int propIndex) {
      switch(propIndex) {
      default:
        return super.getSchemaHelper(propIndex);
      }
    }



    public String getElementName(int propIndex) {
      switch (propIndex) {
        case 9: return "active-type";
        case 10: return "base64-decoding-required";
        case 7: return "compatibility-object-name";
        case 5: return "realm";
        case 8: return "supported-type";
        default: return super.getElementName(propIndex);
      }
    }


    public boolean isArray(int propIndex) {
      switch(propIndex) {
      case 9:
        return true;
      case 8:
        return true;
      default:
        return super.isArray(propIndex);
      }
    }




    public boolean isBean(int propIndex) {
      switch(propIndex) {
      default:
        return super.isBean(propIndex);
      }
    }










  }




  public String wls_getInterfaceClassName() {
    return "weblogic.management.security.authentication.IdentityAsserterMBean"; 
  }

}
