




/*
 * This is a generated file. Do not edit this file.
 */
package weblogic.management.security.authorization;

import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.CRC32;
import weblogic.descriptor.*;
import weblogic.descriptor.BeanUpdateEvent.PropertyUpdate;
import weblogic.descriptor.internal.*;
import weblogic.descriptor.internal.ReferenceManager.Resolver;
import weblogic.descriptor.beangen.LegalChecks;
import weblogic.descriptor.beangen.StringHelper;
import weblogic.utils.ArrayUtils;
import weblogic.utils.StringUtils;
import weblogic.utils.Debug;
import weblogic.utils.collections.ArrayIterator;
import weblogic.utils.collections.CombinedIterator;
import weblogic.descriptor.internal.Munger.ReaderEventInfo;

import weblogic.management.utils.AlreadyExistsException;
import weblogic.management.utils.CreateException;
import weblogic.management.utils.NotFoundException;
import weblogic.management.utils.PropertiesListerMBean;
import weblogic.management.utils.RemoveException;


/**
 * Corresponds to PolicyStoreMBean
 * (Interface=weblogic.management.security.authorization.PolicyStoreMBean)
 * @author Copyright (c) 2003,2014, Oracle and/or its affiliates. All rights reserved.
 * @version 0.1
 *
 * <p>Provides a set of methods for managing policies in a policy store.
 An Authorization-provider or Role Mapping-provider MBean can optionally 
 implement this MBean interface.  Policies are expressed as XACML 2.0 Policy or PolicySet
 documents.</p>
 
 <p>Authorization-providers should expect standard <code>Policy</code> or <code>PolicySet</code> documents
 as described in the XACML 2.0 Core Specification.</p>
 
 <p>Role Mapping-providers should expect <code>Policy</code> or <code>PolicySet</code> documents consistent
 with role assignment policies described by the Role Based Access Control
 Profile, specifically the <code>Target</code> must contain:</p>
 <ul>
 <li>An ActionAttributeDesignator with the id, urn:oasis:names:tc:xacml:1.0:action:action-id, and the value, urn:oasis:names:tc:xacml:2.0:actions:enableRole, according to anyURI-equal</li>
 <li>A ResourceAttributeDesignator with the id, urn:oasis:names:tc:xacml:2.0:subject:role, and a value naming the role being assigned, according to string-equal</li>
 </ul>
 *
 * @xsdgen:complexType.typeName policy-storeType
 * @xsdgen:complexType.targetNamespace http://xmlns.oracle.com/weblogic/security
 */
public class PolicyStoreMBeanImpl
  extends weblogic.management.utils.PropertiesListerMBeanImpl
  implements PolicyStoreMBean, java.io.Serializable
{


  /**
   * 
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=PolicyStoreMBeanImpl)
   *
   */
  public PolicyStoreMBeanImpl() {
    super();
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=PolicyStoreMBeanImpl)
   *
   */
  public PolicyStoreMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1) {
    super(param0, param1);
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=PolicyStoreMBeanImpl)
   *
   */
  public PolicyStoreMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1, boolean param2) {
    super(param0, param1);
    _setTransient(param2);
    _initializeProperty(-1);
  }

  /**
   * Returns cursor listing all policies
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=listAllPolicies)
   *
   */
  public String listAllPolicies()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns cursor listing all policies.  Policies are returned as java.lang.String.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=listAllPoliciesAsString)
   *
   */
  public String listAllPoliciesAsString()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns cursor listing all policy sets
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=listAllPolicySets)
   *
   */
  public String listAllPolicySets()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns cursor listing all policy sets.  Policy sets are returned as java.lang.String.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=listAllPolicySetsAsString)
   *
   */
  public String listAllPolicySetsAsString()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Reads policy with specified identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=readPolicy)
   *
   */
  public com.bea.common.security.xacml.policy.Policy readPolicy(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Reads policy with specified identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=readPolicyAsString)
   *
   */
  public String readPolicyAsString(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Reads policy set with specified identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=readPolicySet)
   *
   */
  public com.bea.common.security.xacml.policy.PolicySet readPolicySet(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Reads policy set with specified identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=readPolicySetAsString)
   *
   */
  public String readPolicySetAsString(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy.  Policy is set to ACTIVE status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicy)
   *
   */
  public void addPolicy(com.bea.common.security.xacml.policy.Policy param0)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy.  Policy is set to ACTIVE status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicy)
   *
   */
  public void addPolicy(String param0)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicy)
   *
   */
  public void addPolicy(com.bea.common.security.xacml.policy.Policy param0, String param1)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicy)
   *
   */
  public void addPolicy(String param0, String param1)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy set.  Policy set is set to ACTIVE status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicySet)
   *
   */
  public void addPolicySet(com.bea.common.security.xacml.policy.PolicySet param0)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy set.  Policy set is set to ACTIVE status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicySet)
   *
   */
  public void addPolicySet(String param0)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy set.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicySet)
   *
   */
  public void addPolicySet(com.bea.common.security.xacml.policy.PolicySet param0, String param1)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Adds policy set.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=addPolicySet)
   *
   */
  public void addPolicySet(String param0, String param1)
    throws CreateException, AlreadyExistsException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy.  This operation does not change the status of policy.
 already present in the store.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicy)
   *
   */
  public void modifyPolicy(com.bea.common.security.xacml.policy.Policy param0)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy.  This operation does not change the status of policy.
 already present in the store.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicy)
   *
   */
  public void modifyPolicy(String param0)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy and status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicy)
   *
   */
  public void modifyPolicy(com.bea.common.security.xacml.policy.Policy param0, String param1)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy and status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicy)
   *
   */
  public void modifyPolicy(String param0, String param1)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy set.  This operation does not change the status of policy set.
 already present in the store.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicySet)
   *
   */
  public void modifyPolicySet(com.bea.common.security.xacml.policy.PolicySet param0)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy set.  This operation does not change the status of policy set.
 already present in the store.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicySet)
   *
   */
  public void modifyPolicySet(String param0)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy set and status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicySet)
   *
   */
  public void modifyPolicySet(com.bea.common.security.xacml.policy.PolicySet param0, String param1)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Updates policy set and status.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicySet)
   *
   */
  public void modifyPolicySet(String param0, String param1)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Sets status for policy identified by identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicyStatus)
   *
   */
  public void modifyPolicyStatus(String param0, String param1, String param2)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns status for policy identified by identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=getPolicyStatus)
   *
   */
  public String getPolicyStatus(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Sets status for policy set identified by identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=modifyPolicySetStatus)
   *
   */
  public void modifyPolicySetStatus(String param0, String param1, String param2)
    throws CreateException, NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns status for policy set identified by identifier and version
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=getPolicySetStatus)
   *
   */
  public String getPolicySetStatus(String param0, String param1)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Deletes policy with given identifier and version.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=deletePolicy)
   *
   */
  public void deletePolicy(String param0, String param1)
    throws NotFoundException, RemoveException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Deletes policy set with given identifier and version.
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=deletePolicySet)
   *
   */
  public void deletePolicySet(String param0, String param1)
    throws NotFoundException, RemoveException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * 
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=_getKey)
   *
   */
  public Object _getKey() {
    return super._getKey();
  }

  /**
   * 
   * (Interface=weblogic.management.security.authorization.PolicyStoreMBean Attribute=_validate)
   *
   */
  public void _validate()
    throws IllegalArgumentException
  {
    super._validate();
  }



 





  protected void _unSet(int idx) {
    if (!_initializeProperty(idx)) {
      super._unSet(idx);
    } else {
      _markSet(idx, false);
    }
  }


  /**
   * @return new instance of helper
   */
  protected AbstractDescriptorBeanHelper _createHelper() {
    return new Helper(this);
  }

  /**
   * @return true if any property is set
   */
  public boolean _isAnythingSet() {
    return super._isAnythingSet()
      ;
  }



  /**
   * @return true if property initialized, false idx refers to a property
   * handled by superclass
   */
  private boolean _initializeProperty(int idx) {
    boolean initOne = idx > -1;
    if (!initOne) {
      idx = -1;
    }
    try {
      switch (idx) {
      default:
        if (initOne) return false;
      }
      return true;
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw (Error)new AssertionError("Impossible Exception").initCause(e);
    }
  }


  /**
   * This helper class contains methods that are used infrequently and
   * can be easily separated from the bean implementations.  It is loaded
   * on demand to minimize memory usage.
   *
   * @xsdgen:complexType.exclude
   */
  protected static class Helper
    extends weblogic.management.utils.PropertiesListerMBeanImpl.Helper
  {
    private PolicyStoreMBeanImpl bean;

    protected Helper(PolicyStoreMBeanImpl bean) {
      super(bean);
      this.bean = bean;
    }

    /**
     * @return property name indexed by propIndex.
     */
    public String getPropertyName(int propIndex) {
      switch (propIndex) {
      default: return super.getPropertyName(propIndex);
      }
    }


    /**
     * @return property index of propName.
     */
    public int getPropertyIndex(String propName) {
      if (false) return -1;
      else return super.getPropertyIndex(propName);
    }

    /**
     * @return iterator over all children
     */
    public Iterator getChildren() {
      List iterators = new ArrayList();
      return new CombinedIterator(iterators);
    }

    /**
     * Compute hash value for version helper
     */
    protected long computeHashValue(CRC32 crc) {
      try {
        StringBuffer buf = new StringBuffer();
        long superValue = super.computeHashValue(crc);
        if (superValue != 0) {
          buf.append(String.valueOf(superValue));
        }

        long childValue = 0;
        crc.update(buf.toString().getBytes());
        return crc.getValue();
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }
    /**
     * Compute difference between this and other
     */
    protected void computeDiff(AbstractDescriptorBean other) {
      try {
        super.computeDiff(other);
      PolicyStoreMBeanImpl otherTyped = (PolicyStoreMBeanImpl)other;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void applyPropertyUpdate(BeanUpdateEvent event, PropertyUpdate update) {
      try {
        PolicyStoreMBeanImpl original = (PolicyStoreMBeanImpl)event.getSourceBean();
        PolicyStoreMBeanImpl proposed = (PolicyStoreMBeanImpl)event.getProposedBean();
        String prop = update.getPropertyName();
        int type = update.getUpdateType();
        if (update.isDerivedUpdate()) {
          return;
        }
        {
          super.applyPropertyUpdate(event, update);
        }
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected AbstractDescriptorBean finishCopy(
    AbstractDescriptorBean initialCopy, boolean includeObsolete, List excludeProps
    ) {
      Object o;
      try {
        PolicyStoreMBeanImpl copy = (PolicyStoreMBeanImpl)initialCopy;
        super.finishCopy(copy, includeObsolete, excludeProps);
        return copy;
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void inferSubTree(Class clazz, Object annotation) {
    	super.inferSubTree(clazz, annotation);
    	Object currentAnnotation = null;
     }
  }


  // FIXME ec@weblogic.com 01-Feb-05 -- no longer used. Remove when ADB method is removed
  public weblogic.descriptor.internal.Munger.SchemaHelper _getSchemaHelper() {
    return null;
  }

  // FIXME ec@weblogic.com 01-Feb-05 -- remove
  public String _getElementName(int propIndex) {
    return _getSchemaHelper2().getElementName(propIndex);
  }

  protected String getSchemaLocation() {
    return "http://xmlns.oracle.com/weblogic/1.0/security.xsd";
  }

  protected String getTargetNamespace() {
    return "http://xmlns.oracle.com/weblogic/security";
  }

  private static SchemaHelper2 _schemaHelper;
  public weblogic.descriptor.internal.SchemaHelper _getSchemaHelper2() {
    if (_schemaHelper == null)
	_schemaHelper = new SchemaHelper2();
    return _schemaHelper;
  }

   // new schema helper
  /**
   * @xsdgen:complexType.exclude
   */
  public static class SchemaHelper2
   extends weblogic.descriptor.internal.AbstractSchemaHelper2
   implements weblogic.descriptor.internal.SchemaHelper
  {
    public int getPropertyIndex(String s) {
      switch(s.length()) {
      default:
        break;
      }
      return super.getPropertyIndex(s);
    }

    public weblogic.descriptor.internal.SchemaHelper getSchemaHelper(int propIndex) {
      switch(propIndex) {
      default:
        return super.getSchemaHelper(propIndex);
      }
    }



    public String getElementName(int propIndex) {
      switch (propIndex) {
        default: return super.getElementName(propIndex);
      }
    }
















  }




  public String wls_getInterfaceClassName() {
    return "weblogic.management.security.authorization.PolicyStoreMBean"; 
  }

}
