




/*
 * This is a generated file. Do not edit this file.
 */
package weblogic.management.security.credentials;

import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.CRC32;
import weblogic.descriptor.*;
import weblogic.descriptor.BeanUpdateEvent.PropertyUpdate;
import weblogic.descriptor.internal.*;
import weblogic.descriptor.internal.ReferenceManager.Resolver;
import weblogic.descriptor.beangen.LegalChecks;
import weblogic.descriptor.beangen.StringHelper;
import weblogic.utils.ArrayUtils;
import weblogic.utils.StringUtils;
import weblogic.utils.Debug;
import weblogic.utils.collections.ArrayIterator;
import weblogic.utils.collections.CombinedIterator;
import weblogic.descriptor.internal.Munger.ReaderEventInfo;

import weblogic.descriptor.DescriptorBean;
import weblogic.management.commo.StandardInterface;
import javax.management.InvalidAttributeValueException;


/**
 * Corresponds to CredentialCacheMBean
 * (Interface=weblogic.management.security.credentials.CredentialCacheMBean)
 * @author Copyright (c) 2003,2014, Oracle and/or its affiliates. All rights reserved.
 * @version 0.1
 *
 * Defines methods used to get/set the
 configuration attributes that are required to support the credential cache.
 *
 * @xsdgen:complexType.typeName credential-cacheType
 * @xsdgen:complexType.targetNamespace http://xmlns.oracle.com/weblogic/security
 * @xsdgen:complexType.ignoreSuper
 */
public class CredentialCacheMBeanImpl
  extends weblogic.management.commo.AbstractCommoConfigurationBean
  implements CredentialCacheMBean, java.io.Serializable
{
  private int _CredentialCacheTTL;
  private boolean _CredentialCachingEnabled;
  private int _CredentialsCacheSize;


  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=CredentialCacheMBeanImpl)
   *
   */
  public CredentialCacheMBeanImpl() {
    super();
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=CredentialCacheMBeanImpl)
   *
   */
  public CredentialCacheMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1) {
    super(param0, param1);
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=CredentialCacheMBeanImpl)
   *
   */
  public CredentialCacheMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1, boolean param2) {
    super(param0, param1);
    _setTransient(param2);
    _initializeProperty(-1);
  }

  /**
   * Returns whether non-null credentials are cached by the credential
 mappers
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialCachingEnabled)
   *
   * @xsdgen:element.name credential-caching-enabled
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @xsdgen:element.default false
   * @dynamic false
   */
  public boolean isCredentialCachingEnabled() {
    return _CredentialCachingEnabled;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialCachingEnabledInherited)
   *
   * return true if the value of property CredentialCachingEnabled is inherited from template
   */
  public boolean isCredentialCachingEnabledInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialCachingEnabledSet)
   *
   * @xsdgen:isSetMethodFor credential-caching-enabled
   */
  public boolean isCredentialCachingEnabledSet() {
    return _isSet(2);
  }

  /**
   * Sets whether credentials, if found, should be cached by the mappers
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=setCredentialCachingEnabled)
   *
   */
  public void setCredentialCachingEnabled(boolean param0)
    throws javax.management.InvalidAttributeValueException
  {
    boolean _oldVal = _CredentialCachingEnabled;
    _CredentialCachingEnabled = param0;
    _postSet(2, _oldVal, param0);
  }

  /**
   * Returns the maximum size of the LRU cache for holding credentials if caching is enabled.
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=getCredentialsCacheSize)
   *
   * @xsdgen:element.name credentials-cache-size
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @xsdgen:element.default 100
   * @dynamic false
   */
  public int getCredentialsCacheSize() {
    return _CredentialsCacheSize;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialsCacheSizeInherited)
   *
   * return true if the value of property CredentialsCacheSize is inherited from template
   */
  public boolean isCredentialsCacheSizeInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialsCacheSizeSet)
   *
   * @xsdgen:isSetMethodFor credentials-cache-size
   */
  public boolean isCredentialsCacheSizeSet() {
    return _isSet(3);
  }

  /**
   * Sets the maximum size of the LRU cache for holding credentails if caching is enabled.
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=setCredentialsCacheSize)
   *
   */
  public void setCredentialsCacheSize(int param0)
    throws javax.management.InvalidAttributeValueException
  {
    int _oldVal = _CredentialsCacheSize;
    _CredentialsCacheSize = param0;
    _postSet(3, _oldVal, param0);
  }

  /**
   * Returns the maximum number of seconds a credential entry is valid in the LRU cache.
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=getCredentialCacheTTL)
   *
   * @xsdgen:element.name credential-cache-ttl
   * @xsdgen:element.required false
   * @xsdgen:element.nillable true
   * @xsdgen:element.default 600
   * @dynamic false
   */
  public int getCredentialCacheTTL() {
    return _CredentialCacheTTL;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialCacheTTLInherited)
   *
   * return true if the value of property CredentialCacheTTL is inherited from template
   */
  public boolean isCredentialCacheTTLInherited() {
    return false;
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=isCredentialCacheTTLSet)
   *
   * @xsdgen:isSetMethodFor credential-cache-ttl
   */
  public boolean isCredentialCacheTTLSet() {
    return _isSet(4);
  }

  /**
   * Sets the maximum number of seconds a credential entry is valid in the LRU cache.
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=setCredentialCacheTTL)
   *
   */
  public void setCredentialCacheTTL(int param0)
    throws javax.management.InvalidAttributeValueException
  {
    int _oldVal = _CredentialCacheTTL;
    _CredentialCacheTTL = param0;
    _postSet(4, _oldVal, param0);
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=_getKey)
   *
   */
  public Object _getKey() {
    return super._getKey();
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.CredentialCacheMBean Attribute=_validate)
   *
   */
  public void _validate()
    throws IllegalArgumentException
  {
    super._validate();
  }



 





  protected void _unSet(int idx) {
    if (!_initializeProperty(idx)) {
      super._unSet(idx);
    } else {
      _markSet(idx, false);
    }
  }


  /**
   * @return new instance of helper
   */
  protected AbstractDescriptorBeanHelper _createHelper() {
    return new Helper(this);
  }

  /**
   * @return true if any property is set
   */
  public boolean _isAnythingSet() {
    return super._isAnythingSet()
      ;
  }



  /**
   * @return true if property initialized, false idx refers to a property
   * handled by superclass
   */
  private boolean _initializeProperty(int idx) {
    boolean initOne = idx > -1;
    if (!initOne) {
      idx = 4;
    }
    try {
      switch (idx) {
      case 4:
        _CredentialCacheTTL = 600;
        if (initOne) break;
      case 3:
        _CredentialsCacheSize = 100;
        if (initOne) break;
      case 2:
        _CredentialCachingEnabled = false;
        if (initOne) break;
      default:
        if (initOne) return false;
      }
      return true;
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw (Error)new AssertionError("Impossible Exception").initCause(e);
    }
  }


  /**
   * This helper class contains methods that are used infrequently and
   * can be easily separated from the bean implementations.  It is loaded
   * on demand to minimize memory usage.
   *
   * @xsdgen:complexType.exclude
   */
  protected static class Helper
    extends weblogic.management.commo.AbstractCommoConfigurationBean.Helper
  {
    private CredentialCacheMBeanImpl bean;

    protected Helper(CredentialCacheMBeanImpl bean) {
      super(bean);
      this.bean = bean;
    }

    /**
     * @return property name indexed by propIndex.
     */
    public String getPropertyName(int propIndex) {
      switch (propIndex) {
      case 4: return "CredentialCacheTTL";
      case 3: return "CredentialsCacheSize";
      case 2: return "CredentialCachingEnabled";
      default: return super.getPropertyName(propIndex);
      }
    }


    /**
     * @return property index of propName.
     */
    public int getPropertyIndex(String propName) {
      if (false) return -1;
      else if (propName.equals("CredentialCacheTTL")) return 4;
      else if (propName.equals("CredentialsCacheSize")) return 3;
      else if (propName.equals("CredentialCachingEnabled")) return 2;
      else return super.getPropertyIndex(propName);
    }

    /**
     * @return iterator over all children
     */
    public Iterator getChildren() {
      List iterators = new ArrayList();
      return new CombinedIterator(iterators);
    }

    /**
     * Compute hash value for version helper
     */
    protected long computeHashValue(CRC32 crc) {
      try {
        StringBuffer buf = new StringBuffer();
        long superValue = super.computeHashValue(crc);
        if (superValue != 0) {
          buf.append(String.valueOf(superValue));
        }

        long childValue = 0;
        if (bean.isCredentialCacheTTLSet()){
          buf.append("CredentialCacheTTL");
          buf.append(String.valueOf(bean.getCredentialCacheTTL()));
        }
        if (bean.isCredentialsCacheSizeSet()){
          buf.append("CredentialsCacheSize");
          buf.append(String.valueOf(bean.getCredentialsCacheSize()));
        }
        if (bean.isCredentialCachingEnabledSet()){
          buf.append("CredentialCachingEnabled");
          buf.append(String.valueOf(bean.isCredentialCachingEnabled()));
        }
        crc.update(buf.toString().getBytes());
        return crc.getValue();
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }
    /**
     * Compute difference between this and other
     */
    protected void computeDiff(AbstractDescriptorBean other) {
      try {
        super.computeDiff(other);
      CredentialCacheMBeanImpl otherTyped = (CredentialCacheMBeanImpl)other;
      computeDiff("CredentialCacheTTL", bean.getCredentialCacheTTL(), otherTyped.getCredentialCacheTTL(), false);
      computeDiff("CredentialsCacheSize", bean.getCredentialsCacheSize(), otherTyped.getCredentialsCacheSize(), false);
      computeDiff("CredentialCachingEnabled", bean.isCredentialCachingEnabled(), otherTyped.isCredentialCachingEnabled(), false);
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void applyPropertyUpdate(BeanUpdateEvent event, PropertyUpdate update) {
      try {
        CredentialCacheMBeanImpl original = (CredentialCacheMBeanImpl)event.getSourceBean();
        CredentialCacheMBeanImpl proposed = (CredentialCacheMBeanImpl)event.getProposedBean();
        String prop = update.getPropertyName();
        int type = update.getUpdateType();
        if (update.isDerivedUpdate()) {
          return;
        }
        if (prop.equals("CredentialCacheTTL")) {
          original.setCredentialCacheTTL(proposed.getCredentialCacheTTL());
          original._conditionalUnset(update.isUnsetUpdate(), 4);
        } else
        if (prop.equals("CredentialsCacheSize")) {
          original.setCredentialsCacheSize(proposed.getCredentialsCacheSize());
          original._conditionalUnset(update.isUnsetUpdate(), 3);
        } else
        if (prop.equals("CredentialCachingEnabled")) {
          original.setCredentialCachingEnabled(proposed.isCredentialCachingEnabled());
          original._conditionalUnset(update.isUnsetUpdate(), 2);
        } else
        {
          super.applyPropertyUpdate(event, update);
        }
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected AbstractDescriptorBean finishCopy(
    AbstractDescriptorBean initialCopy, boolean includeObsolete, List excludeProps
    ) {
      Object o;
      try {
        CredentialCacheMBeanImpl copy = (CredentialCacheMBeanImpl)initialCopy;
        super.finishCopy(copy, includeObsolete, excludeProps);
        if ((excludeProps == null || !excludeProps.contains("CredentialCacheTTL")) && bean.isCredentialCacheTTLSet()) {
          copy.setCredentialCacheTTL((int)bean.getCredentialCacheTTL());
        }
        if ((excludeProps == null || !excludeProps.contains("CredentialsCacheSize")) && bean.isCredentialsCacheSizeSet()) {
          copy.setCredentialsCacheSize((int)bean.getCredentialsCacheSize());
        }
        if ((excludeProps == null || !excludeProps.contains("CredentialCachingEnabled")) && bean.isCredentialCachingEnabledSet()) {
          copy.setCredentialCachingEnabled((boolean)bean.isCredentialCachingEnabled());
        }
        return copy;
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void inferSubTree(Class clazz, Object annotation) {
    	super.inferSubTree(clazz, annotation);
    	Object currentAnnotation = null;
              }
  }


  // FIXME ec@weblogic.com 01-Feb-05 -- no longer used. Remove when ADB method is removed
  public weblogic.descriptor.internal.Munger.SchemaHelper _getSchemaHelper() {
    return null;
  }

  // FIXME ec@weblogic.com 01-Feb-05 -- remove
  public String _getElementName(int propIndex) {
    return _getSchemaHelper2().getElementName(propIndex);
  }

  protected String getSchemaLocation() {
    return "http://xmlns.oracle.com/weblogic/1.0/security.xsd";
  }

  protected String getTargetNamespace() {
    return "http://xmlns.oracle.com/weblogic/security";
  }

  private static SchemaHelper2 _schemaHelper;
  public weblogic.descriptor.internal.SchemaHelper _getSchemaHelper2() {
    if (_schemaHelper == null)
	_schemaHelper = new SchemaHelper2();
    return _schemaHelper;
  }

   // new schema helper
  /**
   * @xsdgen:complexType.exclude
   */
  public static class SchemaHelper2
   extends weblogic.descriptor.internal.AbstractSchemaHelper2
   implements weblogic.descriptor.internal.SchemaHelper
  {
    public int getPropertyIndex(String s) {
      switch(s.length()) {
      case 19:
        if (false) return -1;
        else if (s.equals("credential-cachettl"))
          return 4;
        break;
      case 22:
        if (false) return -1;
        else if (s.equals("credentials-cache-size"))
          return 3;
        break;
      case 26:
        if (false) return -1;
        else if (s.equals("credential-caching-enabled"))
          return 2;
        break;
      default:
        break;
      }
      return super.getPropertyIndex(s);
    }

    public weblogic.descriptor.internal.SchemaHelper getSchemaHelper(int propIndex) {
      switch(propIndex) {
      default:
        return super.getSchemaHelper(propIndex);
      }
    }



    public String getElementName(int propIndex) {
      switch (propIndex) {
        case 4: return "credential-cachettl";
        case 3: return "credentials-cache-size";
        case 2: return "credential-caching-enabled";
        default: return super.getElementName(propIndex);
      }
    }
















  }




  public String wls_getInterfaceClassName() {
    return "weblogic.management.security.credentials.CredentialCacheMBean"; 
  }

}
