




/*
 * This is a generated file. Do not edit this file.
 */
package weblogic.management.security.credentials;

import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.zip.CRC32;
import weblogic.descriptor.*;
import weblogic.descriptor.BeanUpdateEvent.PropertyUpdate;
import weblogic.descriptor.internal.*;
import weblogic.descriptor.internal.ReferenceManager.Resolver;
import weblogic.descriptor.beangen.LegalChecks;
import weblogic.descriptor.beangen.StringHelper;
import weblogic.utils.ArrayUtils;
import weblogic.utils.StringUtils;
import weblogic.utils.Debug;
import weblogic.utils.collections.ArrayIterator;
import weblogic.utils.collections.CombinedIterator;
import weblogic.descriptor.internal.Munger.ReaderEventInfo;

import weblogic.management.utils.InvalidCursorException;
import weblogic.management.utils.ListerMBean;
import weblogic.management.utils.NotFoundException;


/**
 * Corresponds to PKICredentialMapReaderMBean
 * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean)
 * @author Copyright (c) 2003,2014, Oracle and/or its affiliates. All rights reserved.
 * @version 0.1
 *
 * Provides a set of methods for reading a credential map that matches
 users and resources to aliases and their corresponding passwords that can then be used to
 retrieve key information or public certificate information from the configured keystores.
 *
 * @xsdgen:complexType.typeName pki-credential-map-readerType
 * @xsdgen:complexType.targetNamespace http://xmlns.oracle.com/weblogic/security
 */
public class PKICredentialMapReaderMBeanImpl
  extends weblogic.management.utils.ListerMBeanImpl
  implements PKICredentialMapReaderMBean, java.io.Serializable
{


  /**
   * 
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=PKICredentialMapReaderMBeanImpl)
   *
   */
  public PKICredentialMapReaderMBeanImpl() {
    super();
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=PKICredentialMapReaderMBeanImpl)
   *
   */
  public PKICredentialMapReaderMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1) {
    super(param0, param1);
    _initializeProperty(-1);
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=PKICredentialMapReaderMBeanImpl)
   *
   */
  public PKICredentialMapReaderMBeanImpl(weblogic.descriptor.DescriptorBean param0, int param1, boolean param2) {
    super(param0, param1);
    _setTransient(param2);
    _initializeProperty(-1);
  }

  /**
   * Gets the keystore alias that is mapped to a username for a particular resource and credential action.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getKeystoreAlias)
   *
   */
  public String getKeystoreAlias(String param0, String param1, boolean param2, String param3, String param4)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets an username from a list that has been returned
 from the <code>listMappings</code> or the <code>listMappingsByPattern()</code>
 method. This method returns the username that corresponds to current location in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getCurrentInitiatorName)
   *
   */
  public String getCurrentInitiatorName(String param0)
    throws InvalidCursorException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns whether the initiator name from a list that has been returned
 from the <code>listMappings</code> or the <code>listMappingsByPattern()</code>method
 is a user name or a group name.
 Method returns true if the username returned by the getCurrentInitiatorName is a
 user name. If the initiator name returned is a Group name this method returns false.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=isInitiatorUserName)
   *
   */
  public boolean isInitiatorUserName(String param0)
    throws InvalidCursorException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets an credential action from a list that has been returned
 from the <code>listMappings</code> or the <code>listMappingsByPattern()</code> method. This method returns the
 credential action that corresponds to current location in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getCurrentCredAction)
   *
   */
  public String getCurrentCredAction(String param0)
    throws InvalidCursorException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets the keystore alias from a credentials map that has been returned
 from the <code>listMappings</code> or the <code>listMappingsByPattern()</code> method. This method
 returns the keystore alias that corresponds to current location in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getCurrentCredential)
   *
   */
  public String getCurrentCredential(String param0)
    throws InvalidCursorException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets a list of usernames, credential actions, keystore aliases and their passwords.
 Returns  a cursor as a string. Use the
 <code>getCurrentUserName()</code>,<code>getCurrentCredential()</code>,
 <code>getCurrentCredAction()</code> methods to get
 the username, keystore alias and credential action for the current item in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=listMappings)
   *
   */
  public String listMappings(String param0, String param1) {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets the current resource id from a list that has been returned
 from the and <code>listMappingsByPattern()</code> method. This method returns the
 resource id that corresponds to current location in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getCurrentResourceId)
   *
   */
  public String getCurrentResourceId(String param0)
    throws InvalidCursorException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Gets a list of all the configured credential mappings.
 Returns a cursor as a string. Use the
 <code>getCurrentUserName()</code>,<code> getCurrentCredAction()</code>,
 <code> getCurrentResourceId()</code>, <code> getCurrentCredential()</code>
 methods to get the username, credential action, resource id and keystore alias for the
 current item in the list.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=listMappingsByPattern)
   *
   */
  public String listMappingsByPattern(String param0, int param1, String param2) {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns a list of all the public certificate aliases currently configured
 in the keystore.
 Console can call this method to display a list of all
 possible certificate aliases.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=listAllCertEntryAliases)
   *
   */
  public String[] listAllCertEntryAliases()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * Returns a list of all the key pair aliases that currently configured
 in the keystore.
 Console can call this method to display a list of all possible keypair aliases.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=listAllKeypairEntryAliases)
   *
   */
  public String[] listAllKeypairEntryAliases()
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * For a certificate entry this method will return the certificate corresponding
 to the alias. For a keyentry it will return the first Certificate entry
 in a CertificateChain.
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=getCertificate)
   *
   */
  public java.security.cert.Certificate getCertificate(String param0)
    throws NotFoundException
  {
    throw new AssertionError("Method not implemented");
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=_getKey)
   *
   */
  public Object _getKey() {
    return super._getKey();
  }

  /**
   * 
   * (Interface=weblogic.management.security.credentials.PKICredentialMapReaderMBean Attribute=_validate)
   *
   */
  public void _validate()
    throws IllegalArgumentException
  {
    super._validate();
  }



 





  protected void _unSet(int idx) {
    if (!_initializeProperty(idx)) {
      super._unSet(idx);
    } else {
      _markSet(idx, false);
    }
  }


  /**
   * @return new instance of helper
   */
  protected AbstractDescriptorBeanHelper _createHelper() {
    return new Helper(this);
  }

  /**
   * @return true if any property is set
   */
  public boolean _isAnythingSet() {
    return super._isAnythingSet()
      ;
  }



  /**
   * @return true if property initialized, false idx refers to a property
   * handled by superclass
   */
  private boolean _initializeProperty(int idx) {
    boolean initOne = idx > -1;
    if (!initOne) {
      idx = -1;
    }
    try {
      switch (idx) {
      default:
        if (initOne) return false;
      }
      return true;
    } catch (RuntimeException e) {
      throw e;
    } catch (Exception e) {
      throw (Error)new AssertionError("Impossible Exception").initCause(e);
    }
  }


  /**
   * This helper class contains methods that are used infrequently and
   * can be easily separated from the bean implementations.  It is loaded
   * on demand to minimize memory usage.
   *
   * @xsdgen:complexType.exclude
   */
  protected static class Helper
    extends weblogic.management.utils.ListerMBeanImpl.Helper
  {
    private PKICredentialMapReaderMBeanImpl bean;

    protected Helper(PKICredentialMapReaderMBeanImpl bean) {
      super(bean);
      this.bean = bean;
    }

    /**
     * @return property name indexed by propIndex.
     */
    public String getPropertyName(int propIndex) {
      switch (propIndex) {
      default: return super.getPropertyName(propIndex);
      }
    }


    /**
     * @return property index of propName.
     */
    public int getPropertyIndex(String propName) {
      if (false) return -1;
      else return super.getPropertyIndex(propName);
    }

    /**
     * @return iterator over all children
     */
    public Iterator getChildren() {
      List iterators = new ArrayList();
      return new CombinedIterator(iterators);
    }

    /**
     * Compute hash value for version helper
     */
    protected long computeHashValue(CRC32 crc) {
      try {
        StringBuffer buf = new StringBuffer();
        long superValue = super.computeHashValue(crc);
        if (superValue != 0) {
          buf.append(String.valueOf(superValue));
        }

        long childValue = 0;
        crc.update(buf.toString().getBytes());
        return crc.getValue();
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }
    /**
     * Compute difference between this and other
     */
    protected void computeDiff(AbstractDescriptorBean other) {
      try {
        super.computeDiff(other);
      PKICredentialMapReaderMBeanImpl otherTyped = (PKICredentialMapReaderMBeanImpl)other;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void applyPropertyUpdate(BeanUpdateEvent event, PropertyUpdate update) {
      try {
        PKICredentialMapReaderMBeanImpl original = (PKICredentialMapReaderMBeanImpl)event.getSourceBean();
        PKICredentialMapReaderMBeanImpl proposed = (PKICredentialMapReaderMBeanImpl)event.getProposedBean();
        String prop = update.getPropertyName();
        int type = update.getUpdateType();
        if (update.isDerivedUpdate()) {
          return;
        }
        {
          super.applyPropertyUpdate(event, update);
        }
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected AbstractDescriptorBean finishCopy(
    AbstractDescriptorBean initialCopy, boolean includeObsolete, List excludeProps
    ) {
      Object o;
      try {
        PKICredentialMapReaderMBeanImpl copy = (PKICredentialMapReaderMBeanImpl)initialCopy;
        super.finishCopy(copy, includeObsolete, excludeProps);
        return copy;
      // FIXME ehalpern - hack to handle cases where setters throw
      // javax.management.InvalidAttributeValueException.
      } catch (RuntimeException e) {
        throw e;
      } catch (Exception e) {
        throw (Error)new AssertionError("Impossible Exception").initCause(e);
      }
    }

    protected void inferSubTree(Class clazz, Object annotation) {
    	super.inferSubTree(clazz, annotation);
    	Object currentAnnotation = null;
     }
  }


  // FIXME ec@weblogic.com 01-Feb-05 -- no longer used. Remove when ADB method is removed
  public weblogic.descriptor.internal.Munger.SchemaHelper _getSchemaHelper() {
    return null;
  }

  // FIXME ec@weblogic.com 01-Feb-05 -- remove
  public String _getElementName(int propIndex) {
    return _getSchemaHelper2().getElementName(propIndex);
  }

  protected String getSchemaLocation() {
    return "http://xmlns.oracle.com/weblogic/1.0/security.xsd";
  }

  protected String getTargetNamespace() {
    return "http://xmlns.oracle.com/weblogic/security";
  }

  private static SchemaHelper2 _schemaHelper;
  public weblogic.descriptor.internal.SchemaHelper _getSchemaHelper2() {
    if (_schemaHelper == null)
	_schemaHelper = new SchemaHelper2();
    return _schemaHelper;
  }

   // new schema helper
  /**
   * @xsdgen:complexType.exclude
   */
  public static class SchemaHelper2
   extends weblogic.descriptor.internal.AbstractSchemaHelper2
   implements weblogic.descriptor.internal.SchemaHelper
  {
    public int getPropertyIndex(String s) {
      switch(s.length()) {
      default:
        break;
      }
      return super.getPropertyIndex(s);
    }

    public weblogic.descriptor.internal.SchemaHelper getSchemaHelper(int propIndex) {
      switch(propIndex) {
      default:
        return super.getSchemaHelper(propIndex);
      }
    }



    public String getElementName(int propIndex) {
      switch (propIndex) {
        default: return super.getElementName(propIndex);
      }
    }
















  }




  public String wls_getInterfaceClassName() {
    return "weblogic.management.security.credentials.PKICredentialMapReaderMBean"; 
  }

}
